#!/bin/sh

mkdir -p dependencies || exit 1
rm -rf dependencies/* || exit 1
cd dependencies || exit 1

wget https://www.public-software-group.org/pub/projects/moonbridge/v1.1.1/moonbridge-v1.1.1.tar.gz || exit 1
wget https://www.public-software-group.org/pub/projects/singleton/v0.1/singleton-v0.1.tar.gz || exit 1

sha512sum -c ../checksums || exit 1

tar xvzf moonbridge-v1.1.1.tar.gz || exit 1
cd moonbridge-v1.1.1 || exit 1
bmake clean || exit 1
bmake || exit 1
cd .. || exit 1

tar xvzf singleton-v0.1.tar.gz || exit 1

cd .. || exit 1
cd lib || exit

ln -sf ../dependencies/moonbridge-v1.1.1/moonbridge_io.so . || exit 1
ln -sf ../dependencies/singleton-v0.1/singleton.lua . || exit 1

