kiss = {}

kiss.FEND = string.char(0xc0)
kiss.FESC = string.char(0xdb)
kiss.TFEND = string.char(0xdc)
kiss.TFESC = string.char(0xdd)

function kiss.compose_frame(data)
  local port = 0
  local type_indicator = string.char(port << 4)
  -- add KISS escaping
  data = string.gsub(data, kiss.FEND, kiss.FESC .. kiss.TFEND)
  data = string.gsub(data, kiss.FESC, kiss.FESC .. kiss.TFESC)
  local raw = kiss.FEND .. type_indicator .. data .. kiss.FEND
  return raw
end

function kiss.parse_frame(raw)
  -- check for leading and trailing FEND
  if string.sub(raw, 1, 1) ~= kiss.FEND or
     string.sub(raw, #raw, #raw) ~= kiss.FEND
  then
    return nil
  end
  -- extract port and command from type indicator
  local type_indicator = string.byte(string.sub(raw, 2, 2))
  if type_indicator == nil then return end
  local port = (type_indicator >> 4)
  local command = type_indicator & 0x0f
  -- extract data
  local data = string.sub(raw, 3, #raw - 1)
  -- rewove KISS escaping
  data = string.gsub(data, kiss.FESC .. kiss.TFEND, kiss.FEND)
  data = string.gsub(data, kiss.FESC .. kiss.TFESC, kiss.FESC)
  return port, command, data
end

